// src/backend/static_request.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "static_request.hh"

#include <algorithm>
#include <cassert>

using namespace sgpem;
using namespace std;

StaticRequest::StaticRequest(StaticThread* thread,
                             unsigned int instant) :
    _thread(thread), _instant(instant)
{
  assert(thread != NULL);
  _thread->get_requests().push_back(this);
}

StaticRequest::~StaticRequest()
{
  typedef std::vector<StaticRequest*> Requests;
  Requests& siblings = _thread->get_requests();
  siblings.erase(find(siblings.begin(), siblings.end(), this));
}

unsigned int
StaticRequest::get_instant() const
{
  return _instant;
}

unsigned int
StaticRequest::set_instant(unsigned int instant)
{
  unsigned int old_instant = _instant;
  _instant = instant;
  return old_instant;
}

StaticThread&
StaticRequest::get_thread()
{
  return *_thread;
}

